<?PHP //$Id: backuplib.php,v 1.2 2004/11/24 10:11:33 mixik Exp $
    //This php script contains all the stuff to backup/restore
    //newassignment mods
    //Based on code for backup/restore of the assigment module

    //This is the "graphical" structure of the assignment mod:
    //
    //                     assignment
    //                    (CL,pk->id)
    //                        |
    //                        |
    //                        |
    //                 assignment_submisions
    //           (UL,pk->id, fk->assignment,files)
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

 //This function executes all the backup procedure about this mod
    function newassignment_backup_mods($bf,$preferences) {

        global $CFG;

        $status = true;

        //Iterate over assignment table
        $newassignments = get_records ("newassignment","course",$preferences->backup_course,"id");
        if ($newassignments) {
            foreach ($newassignments as $newassignment) {
                //Start mod
                fwrite ($bf,start_tag("MOD",3,true));
                //Print assignment data
                fwrite ($bf,full_tag("ID",4,false,$newassignment->id));
                fwrite ($bf,full_tag("MODTYPE",4,false,"newassignment"));
                fwrite ($bf,full_tag("NAME",4,false,$newassignment->name));
                fwrite ($bf,full_tag("DESCRIPTION",4,false,$newassignment->description));
                fwrite ($bf,full_tag("FORMAT",4,false,$newassignment->format));
                fwrite ($bf,full_tag("RESUBMIT",4,false,$newassignment->resubmit));
                fwrite ($bf,full_tag("TYPE",4,false,$newassignment->type));
                fwrite ($bf,full_tag("MAXBYTES",4,false,$newassignment->maxbytes));
                fwrite ($bf,full_tag("TIMEDUE",4,false,$newassignment->timedue));
                fwrite ($bf,full_tag("GRADE",4,false,$newassignment->grade));
                fwrite ($bf,full_tag("VIEWALL",4,false,$newassignment->viewall));
                fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$newassignment->timemodified));
                //if we've selected to backup users info, then execute backup_assignment_submisions
                if ($preferences->mods["newassignment"]->userinfo) {
                    $status = backup_newassignment_submissions($bf,$preferences,$newassignment->id);
                }
                //End mod
                $status =fwrite ($bf,end_tag("MOD",3,true));
            }
        }
        //if we've selected to backup users info, then backup files too
        if ($status) {
            if ($preferences->mods["newassignment"]->userinfo) {
                $status = backup_newassignment_files($bf,$preferences);
            }
        }
        return $status;
    }

    //Backup newassignment_submissions contents (executed from newassignment_backup_mods)
    function backup_newassignment_submissions ($bf,$preferences,$newassignment) {

        global $CFG;

        $status = true;

        $newassignment_submissions = get_records("newassignment_submissions","newassignment",$newassignment,"id");
        //If there is submissions
        if ($newassignment_submissions) {
            //Write start tag
            $status =fwrite ($bf,start_tag("SUBMISSIONS",4,true));
            //Iterate over each submission
            foreach ($newassignment_submissions as $newass_sub) {
                //Start submission
                $status =fwrite ($bf,start_tag("SUBMISSION",5,true));
                //Print submission contents
                fwrite ($bf,full_tag("ID",6,false,$newass_sub->id));
                fwrite ($bf,full_tag("USERID",6,false,$newass_sub->userid));
                fwrite ($bf,full_tag("TIMECREATED",6,false,$newass_sub->timecreated));
                fwrite ($bf,full_tag("TIMEMODIFIED",6,false,$newass_sub->timemodified));
                fwrite ($bf,full_tag("NUMFILES",6,false,$newass_sub->numfiles));
                fwrite ($bf,full_tag("GRADE",6,false,$newass_sub->grade));
                fwrite ($bf,full_tag("COMMENT",6,false,$newass_sub->comment));
                fwrite ($bf,full_tag("TEACHER",6,false,$newass_sub->teacher));
                fwrite ($bf,full_tag("TIMEMARKED",6,false,$newass_sub->timemarked));
                fwrite ($bf,full_tag("FEEDBACKFILE",6,false,$newass_sub->feedbackfile));
                fwrite ($bf,full_tag("FEEDBACKFILETEACHER",6,false,$newass_sub->feedbackfileteacher));
                fwrite ($bf,full_tag("FEEDBACKTIMEUPLOADED",6,false,$newass_sub->feedbacktimeuploaded));
                fwrite ($bf,full_tag("MAILED",6,false,$newass_sub->mailed));
                //End submission
                $status =fwrite ($bf,end_tag("SUBMISSION",5,true));
            }
            //Write end tag
            $status =fwrite ($bf,end_tag("SUBMISSIONS",4,true));
        }
        return $status;
    }

    //Backup assignment files because we've selected to backup user info
    //and files are user info's level
    function backup_newassignment_files($bf,$preferences) {

        global $CFG;

        $status = true;

        //First we check to moddata exists and create it as necessary
        //in temp/backup/$backup_code  dir
        $status = check_and_create_moddata_dir($preferences->backup_unique_code);
        //Now copy the assignment dir
        if ($status) {
            //Only if it exists !! Thanks to Daniel Miksik.
            if (is_dir($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/newassignment")) {
                $status = backup_copy_file($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/newassignment",
                                           $CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/moddata/newassignment");
            }
        }

        return $status;

    }

    //Return an array of info (name,value)
    function newassignment_check_backup_mods($course,$user_data=false,$backup_unique_code) {
        //First the course data
        $info[0][0] = get_string("modulenameplural","newassignment");
        if ($ids = newassignment_ids ($course)) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        //Now, if requested, the user_data
        if ($user_data) {
            $info[1][0] = get_string("submissions","newassignment");
            if ($ids = newassignment_submission_ids_by_course ($course)) {
                $info[1][1] = count($ids);
            } else {
                $info[1][1] = 0;
            }
        }
        return $info;
    }




    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of assignments id
    function newassignment_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT a.id, a.course
                                 FROM {$CFG->prefix}newassignment a
                                 WHERE a.course = '$course'");
    }

    //Returns an array of assignment_submissions id
    function newassignment_submission_ids_by_course ($course) {

        global $CFG;

        return get_records_sql ("SELECT s.id , s.newassignment
                                 FROM {$CFG->prefix}newassignment_submissions s,
                                      {$CFG->prefix}newassignment a
                                 WHERE a.course = '$course' AND
                                       s.newassignment = a.id");
    }

?>