<?PHP
       //Based on submissions.php of the assignment module

    require_once("../../config.php");
    require_once("lib.php");

    require_variable($id);    // newassignment
    optional_variable($sort, "timemodified"); 
    optional_variable($dir, "DESC");

    if (isset($_POST['timenow'])) {
        $timewas = $_POST['timenow'];
    } else {
        $timewas = 0;
    }
    $timenow = time();

    if (! $newassignment = get_record("newassignment", "id", $id)) {
        error("Course module is incorrect");
    }
    if (! $course = get_record("course", "id", $newassignment->course)) {
        error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance("newassignment", $newassignment->id, $course->id)) {
        error("Course Module ID was incorrect");
    }

    require_login($course->id);

    if (!isteacher($course->id) && $newassignment->viewall == 0) {
        error("Only teachers can access this page");
    }

    if ($course->category) {
        $navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
    }

    $strnewassignments = get_string("modulenameplural", "newassignment");
    $strnewassignment  = get_string("modulename", "newassignment");
    $strsubmissions = get_string("submissions", "newassignment");
    $strsaveallfeedback = get_string("saveallfeedback", "newassignment");

    print_header("$course->shortname: $newassignment->name", "$course->fullname",
                 "$navigation <A HREF=index.php?id=$course->id>$strnewassignments</A> -> 
                  <A HREF=\"view.php?a=$newassignment->id\">$newassignment->name</A> -> $strsubmissions", 
                  "", "", true);

/// Check to see if groups are being used in this assignment
    if ($groupmode = groupmode($course, $cm)) {   // Groups are being used
        $currentgroup = setup_and_print_groups($course, $groupmode, "submissions.php?id=$newassignment->id&sort=$sort&dir=$dir");
    } else {
        $currentgroup = false;
    }


/// Get all teachers and students
    $teachers = get_course_teachers($course->id);

    if ($currentgroup) {
        $users = get_group_users($currentgroup);
    } else {
        $users = get_course_students($course->id);
    }    
    if (!$users) {
        print_heading(get_string("nostudentsyet"));
        print_footer($course);
        exit;
    }

/// Make some easy ways to reference submissions
    if ($submissions = newassignment_get_all_submissions($newassignment, $sort, $dir)) {
        foreach ($submissions as $submission) {
            $submissionbyuser[$submission->userid] = $submission;
        }
    }

/// Get all existing submissions and check for missing ones
    foreach($users as $user) {
        if (!isset($submissionbyuser[$user->id])) {  // Need to create empty entry
            $newsubmission->newassignment = $newassignment->id;
            $newsubmission->userid = $user->id;
            $newsubmission->timecreated = time();
            if (!insert_record("newassignment_submissions", $newsubmission)) {
                error("Could not insert a new empty submission");
            }
        }
    }

    if (isset($newsubmission)) {   // Get them all out again to be sure
        $submissions = newassignment_get_all_submissions($newassignment, $sort, $dir);
    }


/// If data is being submitted, then process it
    if ($data = data_submitted()) {
       
        $feedback = array();
        // Peel out all the data from variable names.
        foreach ($data as $key => $val) {
            if (!in_array($key, array("id", "timenow"))) {
                $type = substr($key,0,1);
                $num  = substr($key,1); 
                $feedback[$num][$type] = $val;
            }
        }

        $count = 0;

        foreach ($feedback as $num => $vals) {
            $submission = $submissions[$num];
            // Only update entries where feedback has actually changed.
            if (($vals['g'] <> $submission->grade) || ($vals['c'] <> addslashes($submission->comment))) {
                unset($newsubmission);
                $newsubmission->grade      = $vals['g'];
                $newsubmission->comment    = $vals['c'];
                $newsubmission->teacher    = $USER->id;
                $newsubmission->timemarked = $timenow;
                $newsubmission->mailed     = 0;           // Make sure mail goes out (again, even)
                $newsubmission->id         = $num;

                // Make sure that we aren't overwriting any recent feedback from other teachers. (see bug #324)
                if ($timewas < $submission->timemarked && (!empty($submission->grade)) && (!empty($submission->comment))) {
                    $u = $users[$submission->userid];
                    $uname = $u->firstname . " " . $u->lastname;
                    notify(get_string("failedupdatefeedback", "newassignment", $uname)
                    . "<br>" . get_string("grade") . ": $newsubmission->grade" 
                    . "<br>" . get_string("feedback", "newassignment") . ": $newsubmission->comment\n");
                    unset($u);
                    unset($uname);
                } else { //print out old feedback and grade
                    if (empty($submission->timemodified)) {   // eg for offline newassignments
                        $newsubmission->timemodified = $timenow;
                    }
                    if (! update_record("newassignment_submissions", $newsubmission)) {
                        notify(get_string("failedupdatefeedback", "newassignment", $submission->userid));
                    } else {
                        $count++;
                    }
                }
            }
        }
        $submissions = newassignment_get_all_submissions($newassignment,$sort, $dir);
        add_to_log($course->id, "newassignment", "update grades", "submissions.php?id=$newassignment->id", "$count users");
        notify(get_string("feedbackupdated", "newassignment", $count));
    } else {
        add_to_log($course->id, "newassignment", "view submissions", "submissions.php?id=$newassignment->id", "$newassignment->id");
    }


	if (!isteacher($course->id) && !isguest() && $newassignment->viewall == 1) {
		$sort="grade";
		$dir="DESC";
		$submissions = newassignment_get_all_others_submissions($newassignment,$sort, $dir);
	    echo "\n<TABLE BORDER=1 CELLSPACING=0 valign=top cellpadding=10 align=center>".
			"\n<TR>\n<TD COLSPAN=2 BGCOLOR=\"$THEME->body\" ALIGN=CENTER VALIGN=TOP>".
			get_string("listedbygrade", "newassignment")."\n</TD>\n</TR>";
	    foreach ($submissions as $submission) {
	        if (isset($users[$submission->userid])) {
                    $user = $users[$submission->userid];
		    newassignment_print_others_assignments($newassignment, $user, $submission);
                }
	    }
		echo "</TABLE>";
	}
	elseif (isteacher($course->id)) {


// Submission sorting

    $sorttypes = array('firstname', 'lastname', 'timemodified', 'grade');

    print_simple_box_start("center", "50%");
    echo '<p align="center">'.get_string('order').':&nbsp;&nbsp;';

    foreach ($sorttypes as $sorttype) {
        if ($sorttype == 'timemodified') {
            $label = get_string("lastmodified");
        } else {
            $label = get_string($sorttype);
        }
        if ($sort == $sorttype) {   // Current sort
            $newdir = $dir == 'ASC' ? 'DESC' : 'ASC';
        } else {
            $newdir = 'ASC';
        }
        echo "<a href=\"submissions.php?id=$newassignment->id&sort=$sorttype&dir=$newdir\">$label</a>";
        if ($sort == $sorttype) {   // Current sort
             $diricon = $dir == 'ASC' ? 'down' : 'up';
             echo " <img src=\"$CFG->pixpath/t/$diricon.gif\" />";
        }
        echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }

    echo "</p>";
    print_simple_box_end();

    print_spacer(8,1); 
    
    $allowedtograde = ($groupmode != VISIBLEGROUPS or isteacheredit($course->id) or ismember($currentgroup));

    if ($allowedtograde) {
        echo '<form action="submissions.php" method="post">';
        echo "<center>";
        echo "<input type=hidden name=sort value=\"$sort\">";
        echo "<input type=hidden name=timenow value=\"$timenow\">";
        echo "<input type=hidden name=id value=\"$newassignment->id\">";
        echo "<input type=submit value=\"$strsaveallfeedback\">";
        echo "</center>";
    }

    $grades = make_grades_menu($newassignment->grade);

    foreach ($submissions as $submission) {
        if (isset($users[$submission->userid])) {   // only users in the given group, if groups are used
            $user = $users[$submission->userid];
            newassignment_print_submission($newassignment, $user, $submission, $teachers, $grades);
        }
    }

    if ($allowedtograde) {
        echo "<center>";
        echo "<input type=hidden name=sort value=\"$sort\">";
        echo "<input type=hidden name=timenow value=\"$timenow\">";
        echo "<input type=hidden name=id value=\"$newassignment->id\">";
        echo "<input type=submit value=\"$strsaveallfeedback\">";
        echo "</center>";
        echo "</form>";
    }
}
    print_footer($course);

?>