<?PHP  // $Id: view.php,v 1.6 2004/12/07 10:33:07 mixik Exp $
       // Based on view.php of the assignment module

    require_once("../../config.php");
    require_once("lib.php");

    optional_variable($id);    // Course Module ID
    optional_variable($a);    // newassignment ID

    if ($id) {
        if (! $cm = get_record("course_modules", "id", $id)) {
            error("Course Module ID was incorrect");
        }

        if (! $course = get_record("course", "id", $cm->course)) {
            error("Course is misconfigured");
        }
    
        if (! $newassignment = get_record("newassignment", "id", $cm->instance)) {
            error("Course module is incorrect");
        }

    } else {
        if (! $newassignment = get_record("newassignment", "id", $a)) {
            error("Course module is incorrect");
        }
        if (! $course = get_record("course", "id", $newassignment->course)) {
            error("Course is misconfigured");
        }
        if (! $cm = get_coursemodule_from_instance("newassignment", $newassignment->id, $course->id)) {
            error("Course Module ID was incorrect");
        }
    }

    require_login($course->id);

    add_to_log($course->id, "newassignment", "view", "view.php?id=$cm->id", "$newassignment->id");

    if ($course->category) {
        $navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
    }

    $strnewassignments = get_string("modulenameplural", "newassignment");
    $strnewassignment  = get_string("modulename", "newassignment");

    print_header("$course->shortname: $newassignment->name", "$course->fullname",
                 "$navigation <A HREF=index.php?id=$course->id>$strnewassignments</A> -> $newassignment->name", 
                  "", "", true, update_module_button($cm->id, $course->id, $strnewassignment), navmenu($course, $cm));


    if (isteacher($course->id)) {
        echo '<p align="right">';
        if ($newassignment->type == NEW_OFFLINE) {
            echo "<a href=\"submissions.php?id=$newassignment->id\">".
                  get_string("viewfeedback", "newassignment")."</a>";
        } else {
            $currentgroup = get_current_group($course->id);
            if ($currentgroup and isteacheredit($course->id)) {
                $group = get_record("groups", "id", $currentgroup);
                $groupname = " ($group->name)";
            } else {
                $groupname = "";
            }
            $count = newassignment_count_real_submissions($newassignment, $currentgroup);
            echo "<a href=\"submissions.php?id=$newassignment->id\">".
                  get_string("viewsubmissions", "newassignment", $count)."</a>$groupname";
        }
        echo '</p>';
    } else if (!$cm->visible) {
        notice(get_string("activityiscurrentlyhidden"));
    }


/// Check to see if groups are being used in this assignment
    $seselect = "";
    $currentgroup = 0;
    if ($groupmode = groupmode($course, $cm)) {  // Groups are being used
        if ($groupmode == SEPARATEGROUPS) {
            if ($currentgroup = get_and_set_current_group($course, $groupmode)) {
                $users = get_group_users($currentgroup);
                if ($users) {
                    $ccc = 0;
                    $seselect = "AND (";
                    foreach ($users as $usrid => $oobj){
                        if ($ccc == 0) {
                            $seselect .= "userid = $usrid";
                        } else {
                            $seselect .= " OR userid = $usrid";
                        }
                        ++$ccc;
                    }
                    $seselect .= ")";
                }
            }
        }
    }
    
    if (!isteacher($course->id) && !isguest() && ($newassignment->viewall == 1) && $newassignment->type == NEW_UPLOADSINGLE && $cm->visible) {
        $count = count_records_select("newassignment_submissions","newassignment = '$newassignment->id' AND timemodified > 0 AND userid != $USER->id $seselect");
	      if ($count > 0) {
            if (($newassignment->timedue - time()) < 0) {	//Show after deadline
	              echo "<P align=right><A HREF=\"submissions.php?id=$newassignment->id&group=$currentgroup\">".
	              get_string("viewothersubmissions", "newassignment", $count)."</A></P>";
            } else {
                $submission = newassignment_get_submission($newassignment, $USER);
                if ($submission && $submission->timemodified && $newassignment->resubmit == 0) {	//Show before deadline if submitted and resubmit not allowed
                    echo "<P align=right><A HREF=\"submissions.php?id=$newassignment->id&group=$currentgroup\">".
                    get_string("viewothersubmissions", "newassignment", $count)."</A></P>";
                }
            }
        }
    }


    print_simple_box_start("CENTER");
    print_heading($newassignment->name, "CENTER");

    $timedifference = $newassignment->timedue - time();
    if ($timedifference < 31536000) {      // Don't bother showing dates over a year in the future
        $strdifference = format_time($timedifference);
        if ($timedifference < 0) {
            $strdifference = "<font color=\"red\">$strdifference</font>";
        }
        $strduedate = userdate($newassignment->timedue)." ($strdifference)";
        echo "<b>".get_string("duedate", "newassignment")."</b>: $strduedate<br />";
    }

    if ($newassignment->grade < 0) {
        $scaleid = - ($newassignment->grade);
        if ($scale = get_record("scale", "id", $scaleid)) {
            $scalegrades = make_menu_from_list($scale->scale);
            echo "<b>".get_string("grade")."</b>: $scale->name ";
            print_scale_menu_helpbutton($course->id, $scale);
            echo "<br />";
        }
    } else if ($newassignment->grade > 0) {
        echo "<b>".get_string("maximumgrade")."</b>: $newassignment->grade<br>";
    }

    echo "<br />";
    echo format_text($newassignment->description, $newassignment->format);
    print_simple_box_end();
    echo "<br />";

    if (!isteacher($course->id) and !isguest()) {
        $submission = newassignment_get_submission($newassignment, $USER);
		    $teachers = get_course_teachers($course->id);

        if ($newassignment->type == NEW_OFFLINE) {
            if ($submission->timemarked) {
                newassignment_print_feedback($course, $newassignment, $USER, $teachers, $submission);
            }
        } else {
            if ($submission and $submission->timemodified) {
                print_simple_box_start("center");
                echo "<center>";
                print_heading(get_string("yoursubmission","newassignment").":", "center");
                echo "<p><font size=-1><b>".get_string("lastmodified")."</b>: ".userdate($submission->timemodified)."</font></p>";
                newassignment_print_user_files($newassignment, $USER);
                print_simple_box_end();
            } else {
                print_heading(get_string("notsubmittedyet","newassignment"));
            }
        
            echo "<hr size=1 noshade>";
        
            if ($submission and $submission->timemarked or $submission->feedbackfile) {
                print_heading(get_string("submissionfeedback", "newassignment").":", "center");
                if (isset($scalegrades)) {
                    $submission->grade = $scalegrades[$submission->grade];
                }
                newassignment_print_feedback($course, $newassignment, $USER, $teachers, $submission);
            }
            if (!$submission->timemarked or $newassignment->resubmit) {
                if ($submission and $submission->timemodified) {
                    echo "<p align=\"center\">".get_string("overwritewarning", "newassignment")."</p>";
                }
                print_heading(get_string("submitnewassignment", "newassignment").":", "center");
                newassignment_print_upload_form($newassignment);
            }
        }
    }

    print_footer($course);

?>